package com.channon.android.androframe_ads;

import android.app.Application;
import android.content.Intent;
import android.preference.PreferenceManager;
import android.util.Log;

import com.channon.android.androframe_ads.objects.DatabaseService;
import com.channon.android.androframe_ads.objects.SwitchScheduler;


public class AndroFrame extends Application {
	
	private static AndroFrame sInstance;
	private DatabaseService dbService;
	SwitchScheduler ssHelper;
	
	@Override
    public void onCreate() {
      super.onCreate();  
      sInstance = this;
      sInstance.initializeInstance();      
    }
	
	protected void initializeInstance() {
        // do all you initialization here
        Log.i("androframe", "application init instance");
    	
        PreferenceManager.setDefaultValues(AndroFrame.getInstance(), R.xml.prefs, false);
        
        ssHelper = new SwitchScheduler(sInstance);
        
        dbService = new DatabaseService();
        
        Intent intent = new Intent(this, CheckLicenses.class);
        startService(intent);
        
    }
	
		
	 public SwitchScheduler getSchedService() {
	    	
	    	return ssHelper;  	
	    	
	    }
	
	public static AndroFrame getInstance() {

		return sInstance;
		
	}
	
	public DatabaseService getDBService() {

		return dbService;
	}
}
