package com.channon.android.androframe_ads;

import com.channon.android.androframe_ads.objects.DatabaseService;
import com.google.ads.AdRequest;
import com.google.ads.AdSize;
import com.google.ads.AdView;

import android.app.TabActivity;
import android.content.Intent;
import android.content.res.Resources;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TabHost;
import android.widget.Toast;
import android.widget.TabHost.OnTabChangeListener;



@SuppressWarnings("deprecation")
public class AndroFrameActivity extends TabActivity {
	Toast mToast;
	private AdView adView;
	private LinearLayout layout;
	
	static final String APP_LOG_NAME = "androframe";
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        setContentView(R.layout.main);
        
        Resources res = getResources(); // Resource object to get Drawables
        TabHost tabHost = getTabHost();  // The activity TabHost
        TabHost.TabSpec spec;  // Reusable TabSpec for each tab
        Intent intent;  // Reusable Intent for each tab
        tabHost.setOnTabChangedListener(new OnTabChangeListener(){

			public void onTabChanged(String tabId) {
				// TODO Auto-generated method stub
				
				Log.i("androswitch","toggling adlayout view");
				toggleAdLayout();
				
			}
        	
        });
        
        layout = (LinearLayout)findViewById(R.id.AdLayout);
        
     // Create an Intent to launch an Activity for the tab (to be reused)
        intent = new Intent().setClass(this, InfoActivity.class);
        
     // Initialize a TabSpec for each tab and add it to the TabHost
        spec = tabHost.newTabSpec("status").setIndicator("Info",
                          res.getDrawable(R.drawable.icon_home))
                      .setContent(intent);
        tabHost.addTab(spec);
        
     // Do the same for the other tabs
        intent = new Intent().setClass(this, ImageManagerActivity.class);
        spec = tabHost.newTabSpec("images").setIndicator("Images",
                          res.getDrawable(R.drawable.icon_images))
                      .setContent(intent);
        tabHost.addTab(spec);
        
        intent = new Intent().setClass(this, ConfigActivity.class);
        spec = tabHost.newTabSpec("settings").setIndicator("Settings",
                          res.getDrawable(R.drawable.icon_settings))
                      .setContent(intent);
        tabHost.addTab(spec);
        
        DatabaseService dbService = ((AndroFrame) getApplicationContext()).getDBService();
		
        String advertise = dbService.getAppPref("advertise");
        Log.i("androframe", "advertise setting from DB:'"+advertise+"'");
        
        if(advertise==null){
        	
        	dbService.setAppPref("advertise", "true");
        	advertise = "true";
        
        }
        
        if(advertise.equals("true")){
	        
        	Log.i("androframe", "advertising");
	        // Create the adView
	        adView = new AdView(this, AdSize.BANNER, "a14eadad735b8de");
	
	        // Lookup your LinearLayout assuming its been given
	        // the attribute android:id="@+id/mainLayout"
	        LinearLayout layout = (LinearLayout)findViewById(R.id.AdLayout);
	        
	        // Add the adView to it
	        layout.addView(adView);
	
	        // Initiate a generic request to load it with an ad
	        adView.loadAd(new AdRequest());
        }
        
        tabHost.setCurrentTab(0);

        
    }
    
    @Override
    public void onResume(){
    	super.onResume();

    	toggleAdLayout();
    	
    }
    
    public void toggleAdLayout(){
		
		DatabaseService dbService = ((AndroFrame) getApplicationContext()).getDBService();
		
        String advertise = dbService.getAppPref("advertise");
        Log.i("androswitch", "advertise setting from DB:'"+advertise+"'");
        
        if(advertise==null){
        	
        	dbService.setAppPref("advertise", "true");
        	advertise = "true";
        
        }
        
     // Create the adView
        adView = new AdView(this, AdSize.BANNER, "a14eada35ed85e1");
        
        if(advertise.equals("true")){
        	layout.setVisibility(View.VISIBLE);
        	
	        // Add the adView to it
	        layout.addView(adView);
	
	        // Initiate a generic request to load it with an ad
	        adView.loadAd(new AdRequest());
        }else{
        	Log.i("androswitch","removing adview");
        	layout.removeView(adView);
        	layout.setVisibility(View.GONE);
        }
	}
}