package com.channon.android.androframe_ads;

import java.util.List;

import com.channon.android.androframe_ads.objects.DatabaseService;

import android.app.IntentService;
import android.content.Intent;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.util.Log;

public class CheckLicenses extends IntentService {

	public CheckLicenses() {
		super("LicenseChecking");
		// TODO Auto-generated constructor stub
	}

	@Override
	protected void onHandleIntent(Intent intent) {
		
		
        
		DatabaseService dbService = ((AndroFrame) getApplicationContext()).getDBService();
		String PaidPackageName = "com.channon.android.androframe";
		String AndroFramePackage = "com.channon.android.androswitch_ads";

		// Grab the Installed Application Info to try to find the one we are
		// looking for
		@SuppressWarnings("rawtypes")
		List list = getPackageManager().getInstalledApplications(
				PackageManager.GET_META_DATA);

		// Loop through the packages and make sure the donate package is
		// actually installed
		boolean isPaid = false;
		boolean aFrame = false;

		for (int i = 0; i < list.size(); i++) {
			ApplicationInfo ai = (ApplicationInfo) list.get(i);

			if (ai.packageName.equals(PaidPackageName)) {
				Log.i("androframe", "paid version found:" + ai.packageName);
				isPaid = true;
			} else if (ai.packageName.equals(AndroFramePackage)) {
				Log.i("androframe", "AndroFrame found:" + ai.packageName);
				aFrame = true;
			}
		}

		if (!isPaid) {
			Log.i("androframe", "paid version not found, removing ads option");
			dbService.setAppPref("license_full", "false");
		} else {
			Log.i("androframe", "paid version found, showing ads option");
			dbService.setAppPref("license_full", "true");
		}
		
		if (!aFrame) {
			Log.i("androframe", "androswitch not found, disabling import option");
			dbService.setAppPref("hasAndroswitch", "false");
		} else {
			Log.i("androframe", "androswitch found, enabling import option");
			dbService.setAppPref("hasAndroswitch", "true");
		}

		stopSelf();
	}

}
