package com.channon.android.androframe_ads;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.net.Uri;
import android.os.Bundle;
import android.preference.CheckBoxPreference;
import android.preference.EditTextPreference;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceClickListener;
import android.preference.PreferenceActivity;
import android.util.Log;

import com.channon.android.androframe_ads.objects.DatabaseService;

public class ConfigActivity extends PreferenceActivity implements OnSharedPreferenceChangeListener {
	int mAppWidgetId;
	int[] appWidgetIds;
	DatabaseService dbService;
	Context mContext;
	public static final String SHOW="SHOW";
	public static final String HIDE="HIDE";
	int mHeight, mWidth;
	
	@Override
    protected void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
            addPreferencesFromResource(R.xml.prefs);
            
            mContext = getBaseContext();
            
            CheckBoxPreference ads = (CheckBoxPreference) findPreference("do_advertise");
            
            dbService = ((AndroFrame) getApplicationContext()).getDBService();
        	
        	String license_full = dbService.getAppPref("license_full");
            
        	if(license_full==null){
        		
        		 Intent intent = new Intent(this, CheckLicenses.class);
        	     startService(intent);
        	     license_full="unknown";
        		
        	}
        	
        	if(license_full.equals("true")){
        		
        		ads.setEnabled(true);
        		
        		String advertise = dbService.getAppPref("advertise");
        		
        		if(advertise==null){
        			
        			dbService.setAppPref("advertise", "true");
        			
        			ads.setChecked(true);
        			
        		}else{
        			
        			if(advertise.equalsIgnoreCase("true")){
        				
        				ads.setChecked(true);
        				
        			}else{
        				
        				ads.setChecked(false);
        				
        			}
        				
        			
        		}
        		
        	}else{
        		
        		ads.setEnabled(false);
        		ads.setSelectable(true);
        		ads.setSummary("Enable with full version");
        		
        	}
        	
        	getPreferenceManager()
	        .findPreference("checkLicenses")
	        .setOnPreferenceClickListener(
	           new OnPreferenceClickListener() {
	         public boolean onPreferenceClick(Preference preference) {
	             
	        	 startCheckLicense();           	 
	        	 
	        	 return false;
	        	 
	         	}
	         });
        	            
            getPreferenceManager()
            .findPreference("clearDB")
            .setOnPreferenceClickListener(
               new OnPreferenceClickListener() {
             public boolean onPreferenceClick(Preference preference) {
                 
            	 dbService = ((AndroFrame) getApplication()).getDBService();
            	 
            	 dbService.dropTables();
            	 
            	 Log.i("androframe","droptables clicked");            	 
            	 
            	 return false;
            	 
             }
         });
            
            
            getPreferenceManager()
            .findPreference("savePrefs")
            .setOnPreferenceClickListener(
               new OnPreferenceClickListener() {
             public boolean onPreferenceClick(Preference preference){      
            
            	 Log.i("androframe","savePrefs clicked");
            	 
            	 	finish();
            	 	
        			
					return false;
        			
             }
         });
	}
	
	public void startCheckLicense(){
		
		Intent intent = new Intent(this, CheckLicenses.class);
        startService(intent);
        
        checkLicense();
	
	}
	
public void checkLicense(){
		
		CheckBoxPreference ads = (CheckBoxPreference) findPreference("do_advertise");
        
        dbService = ((AndroFrame) getApplicationContext()).getDBService();
    	
    	String license_full = dbService.getAppPref("license_full");
        
    	if(license_full==null){
    		
    		 Intent intent = new Intent(this, CheckLicenses.class);
    	     startService(intent);
    	     license_full="unknown";
    		
    	}
    	
    	if(license_full.equals("true")){
    		
    		ads.setEnabled(true);
    		
    		String advertise = dbService.getAppPref("advertise");
    		
    		if(advertise==null){
    			
    			dbService.setAppPref("advertise", "true");
    			
    			ads.setChecked(true);
    			
    		}else{
    			
    			if(advertise.equalsIgnoreCase("true")){
    				
    				ads.setChecked(true);
    				
    			}else{
    				
    				ads.setChecked(false);
    				
    			}
    				
    			
    		}
    		
    	}else{
    		
    		ads.setEnabled(false);
    		ads.setSelectable(true);
    		ads.setSummary("Enable with full version");
    		
    	}
		
	}

	public void savePrefs(){
	
		CheckBoxPreference ads = (CheckBoxPreference) findPreference("do_advertise");
		
		if(ads!=null){
			
			Log.i("androframe","do_advertise pref enabled?"+ads.isEnabled());
			
			if(ads.isEnabled()){
				
				Log.i("androframe","do_advertise pref:"+ads.isChecked());
	        	dbService.setAppPref("advertise", String.valueOf(ads.isChecked()));
			
			
			}
		
		
		}
	
	}
	
	@Override 
    protected void onResume(){
        super.onResume();
        // Set up a listener whenever a key changes
        checkLicense();
        getPreferenceScreen().getSharedPreferences().registerOnSharedPreferenceChangeListener(this);
    }

    @Override 
    protected void onPause() { 
        super.onPause();
        // Unregister the listener whenever a key changes
        savePrefs();
        getPreferenceScreen().getSharedPreferences().unregisterOnSharedPreferenceChangeListener(this);     
    } 
    
    @Override 
    protected void onDestroy(){
    	Log.i("androframe","configactivity ondestroy");
    
    	savePrefs();
 		
    	super.onDestroy();
    	
    }

	public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String key) { 
        updatePrefSummary(findPreference(key));
    }
	
	private void updatePrefSummary(Preference p){
        if (p instanceof CheckBoxPreference) {
        	CheckBoxPreference checkPref = (CheckBoxPreference) p; 
        	p.setSummary(checkPref.getSummary()); 
            
        }
        if (p instanceof EditTextPreference) {
            EditTextPreference editTextPref = (EditTextPreference) p; 
            p.setSummary(editTextPref.getText()); 
        }

    }
	
	@Override
	 protected Dialog onCreateDialog(int id) {
		
		return new AlertDialog.Builder(ConfigActivity.this)
        .setIcon(R.drawable.alert_dialog_icon)
        .setTitle(R.string.info_market_title)
        .setMessage(R.string.info_market_msg)
        .setPositiveButton(R.string.alert_dialog_ok, new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {

            	Intent intent = new Intent(Intent.ACTION_VIEW);
        		intent.setData(Uri.parse("market://details?id=com.channon.android.androframe"));
        		startActivity(intent);
        		
            }
        })
        .setNegativeButton(R.string.alert_dialog_cancel, new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {

            	return;
        		
            }
        })
        .create();
		
	}

}

