package com.channon.android.androframe_ads;

import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.os.AsyncTask;
import android.os.Bundle;
import android.provider.BaseColumns;
import android.provider.MediaStore;
import android.provider.MediaStore.Images.ImageColumns;
import android.provider.MediaStore.MediaColumns;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

import com.channon.android.androframe_ads.objects.AndroSwitchMetadata;
import com.channon.android.androframe_ads.objects.DatabaseService;
import com.channon.android.androframe_ads.objects.EntryAdapter;
import com.channon.android.androframe_ads.objects.EntryItem;
import com.channon.android.androframe_ads.objects.Item;
import com.channon.android.androframe_ads.objects.MediaChooserActivity;
import com.channon.android.androframe_ads.objects.SectionItem;

public class ImageManagerActivity extends ListActivity{
	private ListView lv;
	@SuppressWarnings("rawtypes")
	ArrayList items = new ArrayList();
	public String onBackPressAction;
	public String currentAction;
	
	//List Choices
	public static final int CHOICE_CURRENT = 1;
	public static final int CHOICE_CLEAR = 2;
	public static final int CHOICE_INTERNAL = 4;
	public static final int CHOICE_EXTERNAL = 5;
	
	// Database fields
	public static final String KEY_ROWID = "_id";
	public static final String KEY_PATH = "path";
	public static final String KEY_URI_ID = "uri_id";
	public static final String KEY_FOLDER = "folder";
	
	/*
    public int image_column_index;
    public int dataColumnIndex;
    public int uri_column_index;
    public int bucket_column_index;
    */
	
    //private Cursor imagequery;
    
    //private Map<String, Integer> folders = new HashMap<String, Integer>();
    //private Map<String, Bitmap> thumbs = new HashMap<String, Bitmap>();
	
	static final String[] CHOICES = new String[] {
		"Currently Selected", "Gallery", "External (SD Card)"
	};
	
	private final static String LOGTAG = "com.channon.android.androframe.ImageManagerActivity";
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //setContentView(R.layout.main);
        
        onBackPressAction = "finish";
        currentAction = "topLevel";
        
        generateTopLevel();
        
    }
    
    @SuppressWarnings({ "rawtypes", "unchecked" })
	public void generateTopLevel(){
    	items = new ArrayList();
    	//folders = new HashMap<String, Integer>();
    	//thumbs = new HashMap<String, Bitmap>();
    	
    	items.add(new SectionItem("Make Your Choice:"));
    	items.add(new EntryItem("Add More Images", "Select to add more images",null));
    	items.add(new EntryItem("Managed Currently Selected", "Click to manage your selections",null));
    	
    	DatabaseService dbService = ((AndroFrame) getApplicationContext()).getDBService();
    	String hasAndroframe = dbService.getAppPref("hasAndroswitch");
    	
    	if (hasAndroframe==null){
    		
    	}else if(hasAndroframe.equals("true")){
    		items.add(new EntryItem("Import from AndroSwitch", "Import selections from the AndroSwitch app",null));
    	}
    	
    	EntryAdapter adapter = new EntryAdapter(this, items);       
        setListAdapter(adapter);
        
        lv = getListView();
        lv.setTextFilterEnabled(true);

        lv.setOnItemClickListener(new OnItemClickListener() {
          public void onItemClick(AdapterView<?> parent, View view,
              int position, long id) {
            // When clicked, show a toast with the TextView text
        	  //Toast.makeText(getApplicationContext(), ""+position, Toast.LENGTH_SHORT).show();
        	  
        	  Log.i(LOGTAG, "list position: "+position);
        	  
        	  Item i = (Item) items.get(position);
        	  if(!i.isSection()){
        	  
        		 if(position==1){
        			 generateExternalFolders();
        		 }else if(position==2){
        			 generateSelectionFolders();
        		 }else if(position==3){
        			 importFromAndroswitch();
        		 }
        		  
        	  }
          }
        });
    	
    }
    
    public void importFromAndroswitch(){
		Cursor c = getContentResolver().query(AndroSwitchMetadata.CONTENT_URI, null, null, null, null);
		
		if(c==null){
			
			Log.i("androframe","no slections provided");
		}else{
			int count = c.getCount();
			
			Log.i("androframe",count+" slections provided");
			
			startManagingCursor(c);
			
			DatabaseService dbService = ((AndroFrame) getApplicationContext()).getDBService();
			dbService.addAll(c);
			
			
		}
	}
    
    @SuppressWarnings({ "unchecked", "rawtypes" })
	public void generateSelectionFolders(){
    	
    	items = new ArrayList();
    	//folders = new HashMap<String, Integer>();
    	//thumbs = new HashMap<String, Bitmap>();
    	
    	onBackPressAction = "topLevel";
    	currentAction = "generateSelectionFolders";
    	
    	items.add(new SectionItem("Image Folders from Currently Selected:"));
        
    	ProgressDialog progress = new ProgressDialog(this);
        progress.setMessage("Loading Image Folders...");
        progress.setCancelable(false);
        
    	FolderLoader tl = null;
        tl = new FolderLoader(progress, items, currentAction);
        tl.execute();
    	
    }
    
    @SuppressWarnings({ "unchecked", "rawtypes" })
	public void generateExternalFolders(){
    	
    	items = new ArrayList();
    	//folders = new HashMap<String, Integer>();
    	//thumbs = new HashMap<String, Bitmap>();
    	
    	onBackPressAction = "topLevel";
    	currentAction = "generateExternalFolders";
    	
    	items.add(new SectionItem("Image Folders on Primary Storage:"));
        
    	ProgressDialog progress = new ProgressDialog(this);
        progress.setMessage("Loading Image Folders...");
        progress.setCancelable(false);
        
        FolderLoader tl = null;
        tl = new FolderLoader(progress, items, currentAction);
        tl.execute();
        
        
    }
    
    @SuppressWarnings("rawtypes")
    public class FolderLoader extends AsyncTask<Void, Void, Void> {
		  private ProgressDialog progress;
		  private Cursor imagequery;
		  private String action;
		  private ArrayList items;
		  
		  private int image_column_index;
		  @SuppressWarnings("unused")
		  private int dataColumnIndex;
		  private int uri_column_index;
		  private int bucket_column_index;
		  private int thumb_column;
		  
		  private Map<String, Integer> folders = new HashMap<String, Integer>();
		  private Map<String, Bitmap> thumbs = new HashMap<String, Bitmap>();
		  
		  public FolderLoader(ProgressDialog progress, ArrayList items, String action) {
		    this.progress = progress;
		    this.action = action;
		    this.items = items;
		    
		    folders = new HashMap<String, Integer>();
		    thumbs = new HashMap<String, Bitmap>();
		    
		  }

		  @Override
		  public void onPreExecute() {
		    progress.show();
		    
		    
		    //progress.show(context, title, message, indeterminate, cancelable, cancelListener);
		  }



		@Override
		public void onPostExecute(Void unused) {
		    progress.dismiss();
		    
		    if(action.equals("generateSelectionFolders")){
		    	action = "REMOVE";
		    }else {
		    	action = "ADD";
		    }
		    
		   //imagequery.close();
		    
		    handleReturn(items, action);
		}

		@SuppressWarnings("unchecked")
		@Override
		protected Void doInBackground(Void... params) {
			Log.v(LOGTAG,"doinginbackground");
			
			if(action.equals("generateSelectionFolders")){
				DatabaseService dbService = ((AndroFrame) getApplicationContext()).getDBService();
		        imagequery = dbService.fetchAll();
		        
		        if(imagequery==null){
		        	items.add(new EntryItem("No Image Folders Found", "Manually add images from your gallery app via the Android 'share' button",null));
		        	return null;
		        }
		        
		        startManagingCursor(imagequery);
				
		        image_column_index = imagequery.getColumnIndex(KEY_ROWID);
		        dataColumnIndex = imagequery.getColumnIndex(KEY_PATH);
		        uri_column_index = imagequery.getColumnIndex(KEY_URI_ID);
		        bucket_column_index = imagequery.getColumnIndex(KEY_FOLDER);
				
		        thumb_column = uri_column_index;
		        
			}else if(action.equals("generateExternalFolders")){
				final String[] columns = { MediaColumns.DATA, BaseColumns._ID, ImageColumns.BUCKET_DISPLAY_NAME };
		        final String orderBy = BaseColumns._ID;
		        
		        
		        imagequery = managedQuery(
		                MediaStore.Images.Media.EXTERNAL_CONTENT_URI, columns, null,
		                null, orderBy);
		        Log.i(LOGTAG, "case SOURCE_EXTERNAL");
		        
		        if(imagequery==null){
		        
		        	imagequery = managedQuery(
			                MediaStore.Images.Media.INTERNAL_CONTENT_URI, columns, null,
			                null, orderBy);
		        	Log.i(LOGTAG, "case SOURCE_INTERNAL");
		        }
		        
		        if(imagequery==null){
		        	items.add(new EntryItem("No Image Folders Found", "Manually add images from your gallery app via the Android 'share' button",null));
		        	return null;
		        }
		        
				image_column_index = imagequery.getColumnIndex(BaseColumns._ID);
		        dataColumnIndex = imagequery.getColumnIndex(MediaColumns.DATA);
		        bucket_column_index = imagequery.getColumnIndex(ImageColumns.BUCKET_DISPLAY_NAME);
				
		        thumb_column = image_column_index;
		        
			}else{
				
				return null;
			
			}
				
			if(imagequery.getCount()<=0){
	        	
	        	items.add(new EntryItem("No Image Folders Found", "",null));
	        	
	        }else{
	        	
	        	for(int i = 0; i<imagequery.getCount(); i++){
	        		
	        		imagequery.moveToPosition(i);
	        		
	        		String bucket = imagequery.getString(bucket_column_index);
	        		bucket = URLDecoder.decode(bucket);
	        		
	        		Log.i(LOGTAG, "bucket:"+bucket+" contains:"+folders.containsKey(bucket) );
	        		
	        		if(folders.containsKey(bucket)) {
	        			int count = folders.get(bucket);
	        			Log.i(LOGTAG, "count:"+count);
	        			folders.remove(bucket);
	        			folders.put(bucket, count+1);
	        		}else{
	        			folders.put(bucket, 1);
	        			int id = imagequery.getInt(thumb_column);
	        			thumbs.put(bucket, MediaStore.Images.Thumbnails.getThumbnail(
			                    getApplicationContext().getContentResolver(), id,
			                    MediaStore.Images.Thumbnails.MICRO_KIND, null));
	        			Log.i(LOGTAG, "putting bucket:"+bucket+" at 1");
	        		}
	        		
	        		Log.i(LOGTAG, "bucket:"+bucket+" count:"+folders.get(bucket) );
	        		
	        	}
	        	
	        	Set<String> folderNames = folders.keySet();
	        	
	        	for(String folder : folderNames){
	        		
	        		folder = URLDecoder.decode(folder);
	        		
	        		items.add(new EntryItem(folder, "("+folders.get(folder)+") Images",thumbs.get(folder)));
	        		
	        		Log.i(LOGTAG, "folder name:"+folder+" string:"+"("+folders.get(folder)+") Images");
	        		
	        	}
	        	
	        }

			return null;
		}
	}
    
    @SuppressWarnings({ "unchecked", "rawtypes" })
	public void handleReturn(final ArrayList items, final String action){
    	
    	this.items = items;
    	
    	EntryAdapter adapter = new EntryAdapter(this, this.items);       
        setListAdapter(adapter);
        
        lv = getListView();
        lv.setTextFilterEnabled(true);

        lv.setOnItemClickListener(new OnItemClickListener() {
          public void onItemClick(AdapterView<?> parent, View view,
              int position, long id) {
            // When clicked, show a toast with the TextView text
        	  //Toast.makeText(getApplicationContext(), ""+position, Toast.LENGTH_SHORT).show();
        	  
        	  Log.i(LOGTAG, "list position: "+position);
        	  
        	  Item i = (Item) items.get(position);
        	  if(!i.isSection()){
        	  
        		  startChooser(i.getTitle(), action);
        		  
        	         	  
        	  }
          }
        });
        
    }
    
    
    public void startChooser(String choice, String action){
    	Intent intent = new Intent(getApplicationContext(), MediaChooserActivity.class);
  		intent.putExtra("bucket",choice);
  		
  		intent.setAction(action);

  		startActivityForResult(intent, 0);
    }
    
    @Override
	public void onBackPressed() {
	    
		if(onBackPressAction.equals("topLevel")){
			generateTopLevel();
		}else{
			finish();
		}
    	
	}
    
    @Override
   	public void onPause(){
    	super.onPause();
    	Log.i(LOGTAG,"onPause()");
    }
    
    @Override
   	public void onResume(){
    	super.onResume();
    	Log.i(LOGTAG,"onResume()");
    	
    	if(currentAction.equals("generateExternalFolders")){
    		generateExternalFolders();
    	}else if(currentAction.equals("generateSelectionFolders")){
    		generateSelectionFolders();
    	}else {
    		generateTopLevel();
    	}
    	
    }
} 
    
