package com.channon.android.androframe_ads;

import java.util.ArrayList;

import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ListActivity;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Typeface;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.TextView;

import com.channon.android.androframe_ads.objects.EntryAdapter;
import com.channon.android.androframe_ads.objects.EntryItem;
import com.channon.android.androframe_ads.objects.Item;
import com.channon.android.androframe_ads.objects.SectionItem;

@SuppressWarnings("unchecked")
public class StatusActivity extends ListActivity {
	//Toast mToast;
	
	//PreferenceManager pm;
	//SharedPreferences sp;
	
	private ListView lv;
	@SuppressWarnings("rawtypes")
	ArrayList items = new ArrayList();
	
	//List Choices
	public static final int CHOICE_GENERAL = 1;
	public static final int CHOICE_IMGCHOOSER = 2;
	public static final int CHOICE_PREFS = 3;
	public static final int CHOICE_WIDGET = 4;
	public static final int CHOICE_FEEDBACK = 5;
		
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        Bitmap icon = BitmapFactory.decodeResource(this.getResources(), R.drawable.alert_dialog_icon);
        
        items.add(new SectionItem("Information"));
        items.add(new EntryItem("General", "How AndroFrame works", icon));
        items.add(new EntryItem("Images Chooser", "How to use the image chooser", icon));
        items.add(new EntryItem("Preferences", "How to configure the app", icon));
        items.add(new EntryItem("Widget", "How to use the widget", icon));
        items.add(new EntryItem("Feedback", "Email feedback to the developer", icon));
        
        icon.recycle();
        
        //items.add(new EntryItem("", ""));
        
        EntryAdapter adapter = new EntryAdapter(this, items);       
        setListAdapter(adapter);
        
        lv = getListView();
        //lv = new ListView(this);
        
        lv.setTextFilterEnabled(true);

        lv.setOnItemClickListener(new OnItemClickListener() {
          public void onItemClick(AdapterView<?> parent, View view,
              int position, long id) {
              // When clicked, show a toast with the TextView text
        	  //Toast.makeText(getApplicationContext(), ""+position, Toast.LENGTH_SHORT).show();
        	  
        	  //Log.i("androframe", "list position: "+position);
        	  
        	  Item i = (Item) items.get(position);
        	  if(!i.isSection()){
        	  
        		showDialog(position);
        		
        	  }
          }
    }); 

        
    }
	
	 @Override
	 protected Dialog onCreateDialog(int id) {
	        switch (id) {
	        case CHOICE_GENERAL:
	        	 return new AlertDialog.Builder(StatusActivity.this)
	                .setIcon(R.drawable.alert_dialog_icon)
	                .setTitle(R.string.info_images_title)
	                .setMessage(R.string.info_images_msg)
	                .setPositiveButton(R.string.alert_dialog_ok, new DialogInterface.OnClickListener() {
	                    public void onClick(DialogInterface dialog, int whichButton) {
	    
	                        /* User clicked OK so do some stuff */
	                    }
	                })
	                .create();
	        case CHOICE_IMGCHOOSER:
	        	 return new AlertDialog.Builder(StatusActivity.this)
	                .setIcon(R.drawable.alert_dialog_icon)
	                .setTitle(R.string.info_imgchs_title)
	                .setMessage(R.string.info_imgchs_msg)
	                .setPositiveButton(R.string.alert_dialog_ok, new DialogInterface.OnClickListener() {
	                    public void onClick(DialogInterface dialog, int whichButton) {
	    
	                        /* User clicked OK so do some stuff */
	                    }
	                })
	                .create();
	        case CHOICE_PREFS:
	  	  		 return new AlertDialog.Builder(StatusActivity.this)
	             .setIcon(R.drawable.alert_dialog_icon)
	             .setTitle(R.string.info_prefs_title)
	             .setMessage(R.string.info_prefs_msg)
	             .setPositiveButton(R.string.alert_dialog_ok, new DialogInterface.OnClickListener() {
	                 public void onClick(DialogInterface dialog, int whichButton) {
	 
	                     /* User clicked OK so do some stuff */
	                 }
	             })
	             .create();
  	  		case CHOICE_WIDGET:
	  	  		 return new AlertDialog.Builder(StatusActivity.this)
	             .setIcon(R.drawable.alert_dialog_icon)
	             .setTitle(R.string.info_widget_title)
	             .setMessage(R.string.info_widget_msg)
	             .setPositiveButton(R.string.alert_dialog_ok, new DialogInterface.OnClickListener() {
	                 public void onClick(DialogInterface dialog, int whichButton) {
	 
	                     /* User clicked OK so do some stuff */
	                 }
	             })
	             .create();
  	  		case CHOICE_FEEDBACK:
  	  			
  	  		final Intent emailIntent = new Intent(android.content.Intent.ACTION_SEND);
  	  			emailIntent.setType("plain/text");
  	  			emailIntent.putExtra(android.content.Intent.EXTRA_EMAIL, new String[] { "com.channon.android@gmail.com" });
  	  			emailIntent.putExtra(android.content.Intent.EXTRA_SUBJECT, "AndroFrame Feedback");
  	  			
  	  			//ilIntent.putExtra(android.content.Intent.EXTRA_TEXT, stacktrace);
  	  	
  	  			// START THE EMAIL ACTIVITY - NOTE YOU NEED TO START IT WITH A CHOOSER
  	  	        
  	  			startActivity(Intent.createChooser(emailIntent, "Send feedback..."));

  	  			break;
  	  		}
	        
			return null;
	 }
	 
	
	public View makeView() {
		TextView t = new TextView(this);
        t.setGravity(Gravity.TOP | Gravity.CENTER_HORIZONTAL);
        t.setTextSize(20);
        t.setTypeface(Typeface.create("monospace",1));

        return t;
	}

	public void onClick(View v) {
		
		
		
	}
}
