package com.channon.android.androframe_ads.objects;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import com.channon.android.androframe_ads.AndroFrame;
import com.channon.android.androframe_ads.AndroFrameActivity;
import com.channon.android.androframe_ads.R;
import com.channon.android.androframe_ads.widget.WidgetConfigActivity;
import com.channon.android.androframe_ads.widget.WidgetNextReceiver;
import com.channon.android.androframe_ads.widget.WidgetStartReceiver;
import com.channon.android.androframe_ads.widget.WidgetToggleFrameReceiver;

import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;
import android.view.View;
import android.widget.RemoteViews;

public class BitmapFunctions {
	
	public static final String SHOW="SHOW";
	public static final String HIDE="HIDE";
	public static final String defaultBorder = "widget_frame_wood";
	
	static Map<String, Integer> borders = new HashMap<String, Integer>();
	static {
		borders.put("widget_frame_wood", R.drawable.widget_frame_wood);
		borders.put("widget_frame_metal", R.drawable.widget_frame_metal);
		borders.put("widget_frame_metalwave", R.drawable.widget_frame_metalwave);
		borders.put("widget_frame_jade", R.drawable.widget_frame_jade);
		borders.put("widget_frame_tiedye", R.drawable.widget_frame_tiedye);
		borders.put("widget_frame_flames", R.drawable.widget_frame_flames);
		borders.put("widget_frame_leaves", R.drawable.widget_frame_leaves);
		borders.put("widget_frame_moss", R.drawable.widget_frame_moss);
		borders.put("widget_frame_static", R.drawable.widget_frame_static);
		borders.put("widget_frame_water", R.drawable.widget_frame_water);
		borders.put("widget_frame_watercolor", R.drawable.widget_frame_watercolor);
		//borders.put("widget_frame_transparent", R.drawable.widget_frame_transparent);
		//borders.put("widget_frame_wood_hd", R.drawable.widget_frame_wood_hd);
		//borders.put("widget_frame_threaded_hd", R.drawable.widget_frame_threaded_hd);
			
	}
	
	
	
	public static RemoteViews addViews(Context context, RemoteViews views, int appWidgetId){
		
		return addViews(context, views, appWidgetId, SHOW,800,480);
	}
	
	public static RemoteViews addViews(Context context, RemoteViews views, int appWidgetId,  String touchAction, int mHeight, int mWidth){
		
		if (touchAction == null) touchAction = SHOW;
		
		//SharedPreferences sp=PreferenceManager.getDefaultSharedPreferences(context);
        
		//String borderPref = sp.getString("border", defaultBorder);
		
		DatabaseService dbService = ((AndroFrame) context.getApplicationContext()).getDBService();
		
		String borderPref = dbService.getWPref(appWidgetId, "border"); 
		
		if(borderPref==null) borderPref = defaultBorder;
		
		Log.i("androframe","borderPref: "+borderPref);
		Log.i("androframe","borders.get(borderPref): "+borders.get(borderPref));
		
		views.setImageViewResource(R.id.imageBorder, borders.get(borderPref));
		
		
		
		// Create an Intent to launch receiver
        Intent intent_next = new Intent(context, WidgetNextReceiver.class);
        intent_next.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, appWidgetId);
        intent_next.putExtra("height", mHeight);
        intent_next.putExtra("width", mWidth);
        PendingIntent pendingIntent_next = PendingIntent.getBroadcast(context, appWidgetId, intent_next, PendingIntent.FLAG_UPDATE_CURRENT);
        views.setOnClickPendingIntent(R.id.widgetBtnNext, pendingIntent_next);
        Log.i("androframe", "widget setOnClickPendingIntent next set");
        
        Intent intent_touch = new Intent(context, WidgetToggleFrameReceiver.class);
        intent_touch.setAction(touchAction);
        intent_touch.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, appWidgetId);
        intent_touch.putExtra("height", mHeight);
        intent_touch.putExtra("width", mWidth);
        Log.i("androframe", "extra app widget id: "+AppWidgetManager.EXTRA_APPWIDGET_ID+ " appWidgetId: "+appWidgetId);
        PendingIntent pendingIntent_touch = PendingIntent.getService(context, appWidgetId, intent_touch, PendingIntent.FLAG_UPDATE_CURRENT);
        views.setOnClickPendingIntent(R.id.imageSwitcher1, pendingIntent_touch);
        Log.i("androframe", "widget setOnClickPendingIntent touch set");
        
        Intent intent_start = new Intent(context, WidgetStartReceiver.class);
        intent_start.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, appWidgetId);
        intent_start.putExtra("height", mHeight);
        intent_start.putExtra("width", mWidth);
        PendingIntent pendingIntent_start = PendingIntent.getBroadcast(context, appWidgetId, intent_start, PendingIntent.FLAG_UPDATE_CURRENT);
        views.setOnClickPendingIntent(R.id.widgetBtnStart, pendingIntent_start);
        Log.i("androframe", "widget setOnClickPendingIntent start set");
        
        views.setOnClickPendingIntent(R.id.widgetBtnStop, pendingIntent_start);
        Log.i("androframe", "widget setOnClickPendingIntent stop set");
        
        Intent intent_menu = new Intent(context, AndroFrameActivity.class);
        intent_menu.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, appWidgetId);
        intent_menu.putExtra("height", mHeight);
        intent_menu.putExtra("width", mWidth);
        PendingIntent pendingIntent_menu = PendingIntent.getActivity(context, appWidgetId, intent_menu, PendingIntent.FLAG_UPDATE_CURRENT);
        views.setOnClickPendingIntent(R.id.widgetBtnMenu, pendingIntent_menu);
        
        
        Intent intent_settings = new Intent(context, WidgetConfigActivity.class);
        intent_settings.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, appWidgetId);
        intent_settings.putExtra("height", mHeight);
        intent_settings.putExtra("width", mWidth);
        PendingIntent pendingIntent_settings = PendingIntent.getActivity(context, appWidgetId, intent_settings, PendingIntent.FLAG_UPDATE_CURRENT);
        views.setOnClickPendingIntent(R.id.widgetBtnSettings, pendingIntent_settings);
        
        //RemoteViews adview = new RemoteViews(context.getPackageName(), R.layout.ad_layout);
		
        //views.addView(R.id.frameLayout1, adview);
        
        SwitchScheduler ss = ((AndroFrame) context.getApplicationContext()).getSchedService();
		
        if(ss.isSet(appWidgetId)){
        	
        	views.setViewVisibility(R.id.widgetBtnStart, View.GONE);
        	views.setViewVisibility(R.id.widgetBtnStop, View.VISIBLE);
        }else{
        	
        	views.setViewVisibility(R.id.widgetBtnStop, View.GONE);
        	views.setViewVisibility(R.id.widgetBtnStart, View.VISIBLE);
        	
        }
        	
        
		return views;
		
	}
	
	
	
	public static Bitmap shrinkBitmap(String path, int quality, int mHeight, int mWidth){
		
		if(mHeight == 0 || mWidth == 0){
			mHeight = 800;
			mWidth = 480;
		}
		
		
		Log.i("androframe", "shrinkbitmap called mHeight:"+mHeight+" mWidth:"+mWidth+"path:"+path+" quality:+"+quality);
		
     	BitmapFactory.Options bmpFactoryOptions = new BitmapFactory.Options();
        bmpFactoryOptions.inJustDecodeBounds = true;
        Bitmap bitmap = BitmapFactory.decodeFile(path, bmpFactoryOptions);
        
        int heightRatio = (int)Math.ceil(bmpFactoryOptions.outHeight/(float)mHeight);
        int widthRatio = (int)Math.ceil(bmpFactoryOptions.outWidth/(float)mWidth);
        
        Log.i("androframe", "outHeight: " + bmpFactoryOptions.outHeight + " outWidth: " +  bmpFactoryOptions.outWidth);
        
        if (heightRatio > 1 || widthRatio > 1)
        {
         if (heightRatio > widthRatio)
         {
          
          bmpFactoryOptions.inSampleSize = (int) (heightRatio * 1.5);
         } else {
          bmpFactoryOptions.inSampleSize = (int) (widthRatio * 1.5); 
         }
        }
        
        Log.i("androframe", "inSampleSize:" + bmpFactoryOptions.inSampleSize);
        
        bmpFactoryOptions.inJustDecodeBounds = false;
        
        Log.i("androframe", "decodeFile");
        
        bitmap = BitmapFactory.decodeFile(path, bmpFactoryOptions);

        Log.i("androframe", "outHeight: " + bmpFactoryOptions.outHeight + " outWidth: " +  bmpFactoryOptions.outWidth);

        
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        Log.i("androframe", "compress");
    	boolean didit = bitmap.compress(Bitmap.CompressFormat.JPEG, quality, bos);
        
    	Log.i("androframe", "didit?: "+didit);
    	
        Log.i("androframe", "toByteArray");
        ByteArrayInputStream is = new ByteArrayInputStream(bos.toByteArray());
        
        Log.i("androframe", "toByteArray length:"+bos.toByteArray().length);
        
        
        
        Log.i("androframe", "size of bos: "+bos.size());
        Log.i("androframe", "is: "+is.toString());
        
        try {
			bos.close();
		} catch (IOException e) {

			e.printStackTrace();
		}
        
        Log.i("androframe", "decodeStream");
        bitmap = BitmapFactory.decodeStream(is);

        try {
			is.close();
		} catch (IOException e) {

			e.printStackTrace();
		}

     //System.gc();

     return bitmap;
    }
}
