package com.channon.android.androframe_ads.objects;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.os.Parcelable;
import android.provider.BaseColumns;
import android.provider.MediaStore.Images.ImageColumns;
import android.provider.MediaStore.MediaColumns;
import android.util.Log;
import android.widget.Toast;

import com.channon.android.androframe_ads.AndroFrame;

public class HandleSendIntent extends Activity{
	private final String LOGTAG = "handlesent";
    public int image_column_index;
    public int dataColumnIndex;
    public int uri_column_index;
    public int bucket_column_index;
    
    DatabaseService dbService;
    
    int count = 0;
    int success = 0;
	
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
		
	    Cursor imagecursor;
	    
	    dbService = ((AndroFrame) getApplication()).getDBService();
		
	    Intent intent = getIntent();
	    
		Bundle extras = intent.getExtras();
		String action = intent.getAction();
		
		if (Intent.ACTION_SEND_MULTIPLE.equals(action) && extras.containsKey(Intent.EXTRA_STREAM)) { 
		    ArrayList<Parcelable> list = intent.getParcelableArrayListExtra(Intent.EXTRA_STREAM); 
		    for (Parcelable p : list) { 
		       Uri uri = (Uri) p; 
		       
		       Log.v(LOGTAG, "uri.tostring:"+uri.toString());
	        	String path = uri.getPath();
	        	
	        	Log.v(LOGTAG, "getpath:"+path);
	        	
	        	final String[] columns = { MediaColumns.DATA, BaseColumns._ID, ImageColumns.BUCKET_DISPLAY_NAME };
	            //final String orderBy = BaseColumns._ID;
	            
	            imagecursor = managedQuery(
	                       uri, columns, null,null, null);
	        	
	            if(imagecursor != null){
	            	
	            	if(imagecursor.moveToPosition(0)){
		            	
		            	image_column_index = imagecursor.getColumnIndex(BaseColumns._ID);
		                dataColumnIndex = imagecursor.getColumnIndex(MediaColumns.DATA);
		                bucket_column_index = imagecursor.getColumnIndex(ImageColumns.BUCKET_DISPLAY_NAME);
		                uri_column_index = image_column_index;
		                
		                ChooserItem item = new ChooserItem();
		            	item.ID = imagecursor.getInt(image_column_index);
		            	item.bucket = imagecursor.getString(bucket_column_index);
		            	item.path = imagecursor.getString(dataColumnIndex);
		            	item.uri = imagecursor.getString(uri_column_index);
		                
		                dbService.add(item.path,item.uri,item.bucket);
		            	
		                Log.v(LOGTAG,"successfully added!");
		                
		                
		                success++;
		                
		            }else{
		            	
		            	Log.v(LOGTAG,"unable to move to position 0");

		            }
	            	
	            }
	            
	            
	            count++;
		       
		   } 
		    
		   Toast.makeText(getBaseContext(), "Successfully added "+success+" out of "+count+" images!", Toast.LENGTH_SHORT).show();
		
		
		} 
		
		if (Intent.ACTION_SEND.equals(action))
	    {
	        if (extras.containsKey(Intent.EXTRA_STREAM))
	        {
	        	
	        	Uri uri = (Uri) extras.getParcelable(Intent.EXTRA_STREAM);
	        	Log.v(LOGTAG, "uri.tostring:"+uri.toString());
	        	String path = uri.getPath();
	        	
	        	Log.v(LOGTAG, "getpath:"+path);
	        	
	        	final String[] columns = { MediaColumns.DATA, BaseColumns._ID, ImageColumns.BUCKET_DISPLAY_NAME };
	            //final String orderBy = BaseColumns._ID;
	            
	            imagecursor = managedQuery(
	                       uri, columns, null,null, null);
	        	
	            if(imagecursor != null){
	            
		            if(imagecursor.moveToPosition(0)){
		            	
		            	image_column_index = imagecursor.getColumnIndex(BaseColumns._ID);
		                dataColumnIndex = imagecursor.getColumnIndex(MediaColumns.DATA);
		                bucket_column_index = imagecursor.getColumnIndex(ImageColumns.BUCKET_DISPLAY_NAME);
		                uri_column_index = image_column_index;
		                
		                ChooserItem item = new ChooserItem();
		            	item.ID = imagecursor.getInt(image_column_index);
		            	item.bucket = imagecursor.getString(bucket_column_index);
		            	item.path = imagecursor.getString(dataColumnIndex);
		            	item.uri = imagecursor.getString(uri_column_index);
		                
		                dbService.add(item.path,item.uri,item.bucket);
		            	
		                Log.v(LOGTAG,"successfully added!");
		                Toast.makeText(getBaseContext(), "Image successfully added!", Toast.LENGTH_SHORT).show();
		                
		                return;
		                
		            }else{
		            	
		            	Log.v(LOGTAG,"unable to move to position 0");
		            	Toast.makeText(getBaseContext(), "Sorry, unable to add image", Toast.LENGTH_SHORT).show();
		            	
		            	return;
		            	
		            }
	            }
	            
	            Log.v(LOGTAG,"unable to move to position 0");
            	Toast.makeText(getBaseContext(), "Sorry, unable to add image", Toast.LENGTH_SHORT).show();
	        }
	    
	    }
		
		
		
		finish();
		
	}
	
}
