package com.channon.android.androframe_ads.objects;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.content.Context;
import android.content.Intent;
import android.os.SystemClock;
import android.util.Log;
import android.widget.Toast;

import com.channon.android.androframe_ads.AndroFrame;
import com.channon.android.androframe_ads.widget.SwitchReceiver;

public class SwitchScheduler{
	Toast mToast;
	Context mContext;
	//Intent intent;
	
	//SharedPreferences sp;
	
	public SwitchScheduler(Context context){
		mContext = context;
		
		//Intent intent = new Intent(context, SwitchReceiver.class);
	}
	
	public boolean isSet(int appWidgetId){
		Intent intent = new Intent(mContext, SwitchReceiver.class);
		PendingIntent check =PendingIntent.getBroadcast(mContext, appWidgetId, intent, PendingIntent.FLAG_NO_CREATE);
		boolean c = (check != null);
		Log.i("androframe", "check: "+c);
		return c;
	}
	
	public boolean start(int appWidgetId){
		Intent intent = new Intent(mContext, SwitchReceiver.class);
		intent.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, appWidgetId);
		
		DatabaseService dbService = ((AndroFrame) mContext).getDBService();
		
		String _interval = dbService.getWPref(appWidgetId, "interval");
        Log.i("androframe", "_interval value: "+_interval);
        
        if(_interval==null){
        	_interval = "300";
        	dbService.setWPref(appWidgetId, "interval", _interval);        
        }
        
        long interval = Integer.parseInt(_interval); 
        interval = interval*1000;
        
        long firstTime = SystemClock.elapsedRealtime();
        firstTime += interval;
        
        PendingIntent sender = PendingIntent.getBroadcast(AndroFrame.getInstance(), appWidgetId, intent, 0);
        AlarmManager am = (AlarmManager)mContext.getSystemService(Context.ALARM_SERVICE);
        am.setRepeating(AlarmManager.ELAPSED_REALTIME_WAKEUP,firstTime, interval, sender);

        // Tell the user about what we did.
        if (mToast != null) {
            mToast.cancel();
        }
        
        mToast = Toast.makeText(mContext, "Switcher scheduled to occur every "+_interval+" seconds",
                Toast.LENGTH_LONG);
        mToast.show();
        
		return true;
		
	}
	
	public boolean stop(int appWidgetId){
		Intent intent = new Intent(mContext, SwitchReceiver.class);
		
		PendingIntent sender = PendingIntent.getBroadcast(mContext, appWidgetId, intent, 0);
		AlarmManager am = (AlarmManager)mContext.getSystemService(Context.ALARM_SERVICE);
        am.cancel(sender);
        sender.cancel();
        
        // Tell the user about what we did.
        if (mToast != null) {
            mToast.cancel();
        }
        mToast = Toast.makeText(mContext, "Switcher unscheduled",
                Toast.LENGTH_LONG);
        mToast.show();

		return true;
		
	}
	
}
