package com.channon.android.androframe_ads.widget;

import java.io.File;

import android.appwidget.AppWidgetManager;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.widget.RemoteViews;
import android.widget.Toast;

import com.channon.android.androframe_ads.AndroFrame;
import com.channon.android.androframe_ads.R;
import com.channon.android.androframe_ads.objects.BitmapFunctions;
import com.channon.android.androframe_ads.objects.DatabaseService;

public class SwitchReceiver extends BroadcastReceiver {

	//Context mContext;
	Intent mIntent;
	boolean isRand;
	int mHeight;
	int mWidth;
	int appWidgetId;
	AppWidgetManager appWidgetManager;
	DatabaseService dbService;
	//RemoteViews views;
	
	public static final String HIDE="hide";
	
	//FileOutputStream fos;
	
	@Override
	public void onReceive(Context context, Intent intent) {
		
		Log.i("androframe", "broadcast received");
		dbService = ((AndroFrame) context.getApplicationContext()).getDBService();
		
		mIntent = intent;
		if(mIntent.hasExtra("height")) mHeight = mIntent.getIntExtra("height", 800);
		if(mIntent.hasExtra("width")) mWidth = mIntent.getIntExtra("width", 480);
		
		
		appWidgetManager = AppWidgetManager
				.getInstance(context.getApplicationContext());
		
		appWidgetId = mIntent.getExtras().getInt(AppWidgetManager.EXTRA_APPWIDGET_ID);
		
		//Toast.makeText(context, "Changing Wallpaper", Toast.LENGTH_SHORT).show();
		//SharedPreferences sp=PreferenceManager.getDefaultSharedPreferences(context);
        
		//isRand=sp.getBoolean("randomize", false);
        String temp = dbService.getWPref(appWidgetId, "randomize"); 
		
        if(temp.equalsIgnoreCase("true")) {
			isRand = true;
		}else{
			isRand = false;
		}
        
		Log.i("androframe", "randomize check: "+isRand);
       
		//final WallpaperManager wallpaperManager = WallpaperManager.getInstance(mContext);
		RemoteViews views = new RemoteViews(context.getPackageName(), R.layout.widget_layout);
		
		Log.i("androframe", "advance");
        views = advance(views);
        
        if(views==null){
        	Toast.makeText(context, "No wallpapers to switch, add more from the chooser", Toast.LENGTH_SHORT).show();
        	views = new RemoteViews(context.getPackageName(), R.layout.widget_layout);
        }
        
        //Log.i("androframe", "gc");
        //System.gc();
        
        Log.i("androframe", "addIntents");
        views = BitmapFunctions.addViews(context, views, appWidgetId);
        
        Log.i("androframe", "updateAppWidget free memory: "+ Runtime.getRuntime().freeMemory());
        appWidgetManager.updateAppWidget(appWidgetId, views);
      
	}
	



	public RemoteViews advance(RemoteViews views) {
		
		String path = null;
		
		
		
		
        boolean advanced = false;
        
        while(!advanced){
        
			if(isRand){
	        	path = dbService.fetchRandom(appWidgetId);
	        	Log.i("androframe", "fetched random: "+path);
	        }else{
	        	path = dbService.fetchNext(appWidgetId);
	        	Log.i("androframe", "fetched next: "+path);
	        }
			
			
			
			if((path==null)){
				//Toast.makeText(mContext, "No wallpapers to switch, add more from the chooser", Toast.LENGTH_SHORT).show();
				
				advanced = false;
				
				return null;
				
				
			}else{
				
				File file = new File(path);
				
		        if(file.exists()){
					Log.i("androframe", "trying to set bitmap");
					//wallpaperManager.setBitmap(ShrinkBitmap(path,wallpaperManager.getDesiredMinimumWidth(),wallpaperManager.getDesiredMinimumHeight(),80));
					//views.setImageViewResource(R.id.imageSwitcher1, R.drawable.widget_frame);
					
					//views.setImageViewBitmap(R.id.imageSwitcher1, ShrinkBitmap(path,wallpaperManager.getDesiredMinimumWidth(),wallpaperManager.getDesiredMinimumHeight(),100));
					
					views.setImageViewBitmap(R.id.imageSwitcher1,BitmapFunctions.shrinkBitmap(path,100, mHeight, mWidth));
					
					Log.i("androframe", "bitmap set at 100%");
					
					views.setViewVisibility(R.id.warning, View.GONE);

					
					Log.i("androframe", "extra app widget id: "+AppWidgetManager.EXTRA_APPWIDGET_ID+ " appWidgetId: "+appWidgetId);
					
					advanced = true;
				}else{
					
					Log.i("androframe","file: "+path+" does not exist, removing from DB");
					dbService.delete(path);
					
					//Log.i("androframe","No wallpapers to switch, add more from the chooser");
					advanced = false;
				}
			}
        }
        
		return views;
	}
	
}