package com.channon.android.androframe_ads.widget;

import android.app.AlertDialog;
import android.app.Dialog;
import android.appwidget.AppWidgetManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.os.Bundle;
import android.preference.CheckBoxPreference;
import android.preference.EditTextPreference;
import android.preference.ListPreference;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceClickListener;
import android.preference.PreferenceActivity;
import android.util.Log;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.RemoteViews;

import com.channon.android.androframe_ads.AndroFrame;
import com.channon.android.androframe_ads.R;
import com.channon.android.androframe_ads.objects.BitmapFunctions;
import com.channon.android.androframe_ads.objects.DatabaseService;
import com.channon.android.androframe_ads.objects.WidgetSharedPreferences;
import com.google.ads.AdRequest;
import com.google.ads.AdSize;
import com.google.ads.AdView;

public class WidgetConfigActivity extends PreferenceActivity implements OnSharedPreferenceChangeListener{
	int mAppWidgetId;
	DatabaseService dbService;
	Context mContext;
	Bundle wPrefs;
	
	private AdView adView;
	
	public WidgetSharedPreferences prefs;
	
	int mHeight, mWidth;
	
	@Override
	public SharedPreferences getSharedPreferences(String name, int mode) {
		
		Log.d("androframe", String.format("getSharedPreferences(name=%s, mode=%s)", name, mode));
		
		if(name.equals("com.channon.android.androframe_ads_preferences")) {
			return this.prefs;
		}else{
			return super.getSharedPreferences(name, mode);
		}
		
	}

	@Override
    protected void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
           // PreferenceManager.setDefaultValues(this, R.xml.widget_prefs, false);
            
            dbService = ((AndroFrame) getApplicationContext()).getDBService();
            
            Intent intent = getIntent();
            Bundle extras = intent.getExtras();
            
            if (extras != null) {
                mAppWidgetId = extras.getInt(
                        AppWidgetManager.EXTRA_APPWIDGET_ID, 
                        AppWidgetManager.INVALID_APPWIDGET_ID);
            }
            
            Log.i("androframe","widget config activity started for widget id: "+mAppWidgetId);
            
            
            
            //AppWidgetManager appWidgetManager;
        	//appWidgetManager = AppWidgetManager.getInstance(mContext);
        	
            
            
        	
        	
        	String advertise = dbService.getAppPref("advertise");
            Log.i("androframe", "advertise setting from DB:'"+advertise+"'");
            
            if(advertise == null){
            	advertise = "true";
            }
            
            if(advertise.equals("true")){
    	        
            	Log.i("androframe", "advertising");
    	        // Create the adView
    	        adView = new AdView(this, AdSize.BANNER, "a14eadad735b8de");
    	
    	        ViewGroup view = (ViewGroup)getWindow().getDecorView();
    	        
    	        
    	        
    	        LinearLayout layout = (LinearLayout)view.getChildAt(0);
    	        
    	        // Add the adView to it
    	        layout.addView(adView);
    	            	        
    	        // Initiate a generic request to load it with an ad
    	        adView.loadAd(new AdRequest());
    	   
            }
        	
            
        	this.prefs = new WidgetSharedPreferences(dbService, mAppWidgetId);
        	this.prefs.registerOnSharedPreferenceChangeListener(this);

        	this.addPreferencesFromResource(R.xml.widget_prefs);
        
        	this.updateSummaries("all");
        	
        	
        	
        	getPreferenceManager()
            .findPreference("savePrefs")
            .setOnPreferenceClickListener(
               new OnPreferenceClickListener() {
             public boolean onPreferenceClick(Preference preference){      
            
            	 Log.i("androframe","savePrefs clicked");
            	 	
            	 	prefs.edit().commit();
            	 
            		Intent resultValue = new Intent();
        			resultValue.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, mAppWidgetId);
        			setResult(RESULT_OK, resultValue);
        			
        			
        			finish();
        			
					return false;
        			
             }
         });
	}
	
	
	
	@Override 
    protected void onDestroy(){
    	super.onDestroy();
    	
    	/*
    	AppWidgetManager appWidgetManager = AppWidgetManager.getInstance(getBaseContext());
    	RemoteViews views = new RemoteViews(getPackageName(),
		R.layout.widget_layout);
    	
    	ComponentName cn = new ComponentName(getBaseContext(), WidgetProvidor.class);
		
    	int[] appWidgetIds = appWidgetManager.getAppWidgetIds(cn);
    	
    	for (int i=0; i<appWidgetIds.length; i++) {
            int appWidgetId = appWidgetIds[i];
    	
            views = WidgetProvidor.addViews(getBaseContext(), views, appWidgetId, "SHOW");
    	
            appWidgetManager.updateAppWidget(appWidgetId, views);
		
    	}
    	*/
    	//adView.destroy();
    	
    	AppWidgetManager appWidgetManager = AppWidgetManager.getInstance(getBaseContext());
    	RemoteViews views = new RemoteViews(getPackageName(), R.layout.widget_layout);
    	views = BitmapFunctions.addViews(getBaseContext(), views, mAppWidgetId);
    	appWidgetManager.updateAppWidget(mAppWidgetId, views);
    	
	}
	
	@Override
	public void onBackPressed() {
	    // your code.
		
		showDialog(0);

		
	}
	
	@Override
	 protected Dialog onCreateDialog(int id) {
	       
	        	 return new AlertDialog.Builder(WidgetConfigActivity.this)
	                .setIcon(R.drawable.alert_dialog_icon)
	                .setTitle(R.string.discard_changes)
	                .setMessage(R.string.info_discard_changes)
	                .setPositiveButton(R.string.alert_dialog_save, new DialogInterface.OnClickListener() {
	                    public void onClick(DialogInterface dialog, int whichButton) {
	                    	
	                    	prefs.edit().commit();
	                   	 
	                		Intent resultValue = new Intent();
	            			resultValue.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, mAppWidgetId);
	            			setResult(RESULT_OK, resultValue);
	            			
	                        finish();
	                        
	                    }
	                })
	                .setNeutralButton(R.string.alert_dialog_cancel, new DialogInterface.OnClickListener() {
	                 public void onClick(DialogInterface dialog, int whichButton) {

	                 	return;
	             		
	                 }
	                })
	                .setNegativeButton(R.string.alert_dialog_exit, new DialogInterface.OnClickListener() {
	                 public void onClick(DialogInterface dialog, int whichButton) {

	                	Intent resultValue = new Intent();
	            		resultValue.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, mAppWidgetId);
	            		setResult(RESULT_CANCELED, resultValue);
	            			
	                	finish();
	             		
	                 }
	                })
	                
	             .create();
    }
	
	public void updateSummaries(String pkey) {
		// for all text preferences, set hint as current database value
		
		if(pkey==null) {
			for(String key : this.prefs.values.keySet()) {
				Preference pref = this.findPreference(key);
				if(pref == null) continue;
				if(pref instanceof CheckBoxPreference) pref.setSummary(prefs.getString(key,""));
				if(pref instanceof EditTextPreference) pref.setSummary(prefs.getString(key, ""));
				if(pref instanceof ListPreference) pref.setSummary(prefs.getString(key, ""));
			}
		}else{
			
			if(pkey.equals("all")){
				for(String key : this.prefs.values.keySet()) {
					Preference pref = this.findPreference(key);
					if(pref == null) continue;
					if(pref instanceof CheckBoxPreference) pref.setSummary(prefs.getString(key,""));
					if(pref instanceof EditTextPreference) pref.setSummary(prefs.getString(key, ""));
					if(pref instanceof ListPreference) pref.setSummary(prefs.getString(key, ""));
				}
			}
			
			Preference pref = findPreference(pkey);
			
			if(pref instanceof CheckBoxPreference) pref.setSummary(prefs.getString(pkey,""));
			if(pref instanceof EditTextPreference) pref.setSummary(prefs.getString(pkey, ""));
			if(pref instanceof ListPreference) pref.setSummary(prefs.getString(pkey, ""));
		
		}
	}
	
	public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String key) {
		// update values on changed preference
		this.updateSummaries(key);
		
	}
	
	@Override 
    protected void onResume(){
        super.onResume();
        // Set up a listener whenever a key changes             
        getPreferenceScreen().getSharedPreferences().registerOnSharedPreferenceChangeListener(this);
    }
	
	@Override 
	protected void onPause() { 
	    super.onPause();
	    // Unregister the listener whenever a key changes             
	    getPreferenceScreen().getSharedPreferences().unregisterOnSharedPreferenceChangeListener(this);     
	} 
	
}
