package com.channon.android.androframe_ads.widget;

import android.appwidget.AppWidgetManager;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.widget.RemoteViews;

import com.channon.android.androframe_ads.AndroFrame;
import com.channon.android.androframe_ads.R;
import com.channon.android.androframe_ads.objects.BitmapFunctions;
import com.channon.android.androframe_ads.objects.SwitchScheduler;

public class WidgetStartReceiver extends BroadcastReceiver {
	
	AppWidgetManager appWidgetManager;
	
	@Override
	public void onReceive(Context context, Intent intent) {

		Log.i("androframe", "widgetstartreceiver called");
		
		int appWidgetId = intent.getExtras().getInt(AppWidgetManager.EXTRA_APPWIDGET_ID);
		Log.i("androframe", "EXTRA_APPWIDGET_ID:"+appWidgetId);
		
		SwitchScheduler ss;
		ss = AndroFrame.getInstance().getSchedService();
		
		if(ss.isSet(appWidgetId)){
        	ss.stop(appWidgetId);
        	Log.i("androframe", "widgetreceiver stopped switcher");
		}else{
			
			ss.start(appWidgetId);
			Log.i("androframe", "widgetreceiver started switcher");
		}
		
		RemoteViews views = new RemoteViews(context.getPackageName(), R.layout.widget_layout);
		views = BitmapFunctions.addViews(context, views, appWidgetId);
		
		appWidgetManager = AppWidgetManager
				.getInstance(context.getApplicationContext());
		appWidgetManager.updateAppWidget(appWidgetId, views);
		
		
	}
}
